#include "Frazione.h"

/* metodi privati */
int Frazione::MCD(int a, int b)
{
	int r;
	
	if (b > a)
	{
		r = a;
		a = b;
		b = r;
	}
	if (b==0)
		return a;
	while (b > 0)
	{
		r = a % b;
		a = b;
		b = r;
	}
	return a;
}

void Frazione::semplifica()
{
int div;
if (num == 0)
return;
div = MCD(den,num);
num = num/div;
den = den/div;
}

/* costruttori */
Frazione::Frazione(void)
{
num = 0;
den = 1;
}

Frazione::Frazione(int n, int d)
{
if (d != 0)
{
num = n;
den = d;
semplifica();
}
else
{
num = 0;
den = 1;
}
}

/* metodi di accesso */
void Frazione::setNum(int n)
{
num = n;
}

void Frazione::setDen(int d)
{
if (d != 0)
{
den = d;
}
}

int Frazione::getNum(void)
{
return num;
}

int Frazione::getDen(void)
{
return den;
}

/* metodi di implementazione delle operazioni */
Frazione Frazione::somma(Frazione f)
{
Frazione r;
r.setDen(den*f.getDen());
r.setNum(num*f.getDen() + f.getNum()*den);
semplifica();
return r;
}

Frazione Frazione::differenza(Frazione f)
{
Frazione r;
r.setDen(den*f.getDen());
r.setNum(num*f.getDen() - f.getNum()*den);
semplifica();
return r;
}

Frazione Frazione::prodotto(Frazione f)
{
Frazione r;
r.setNum(num*f.getNum());
r.setDen(den*f.getDen());
semplifica();
return r;
}

Frazione Frazione::quoziente(Frazione f)
{
Frazione r;
r.setNum(num*f.getDen());
r.setDen(den*f.getNum());
semplifica();
return r;
}

