class Magazzino
{
	private:
	
	unsigned int *prodotti;
	unsigned int numero_prodotti;
	
	public:
	
	Magazzino(unsigned int numero_prodotti)
	{
		this->numero_prodotti = numero_prodotti;
		prodotti = new unsigned int[numero_prodotti];
		for (int prodotto=0; prodotto<numero_prodotti; prodotto++)
			prodotti[prodotto] = 0;
	}
	
	~Magazzino()
	{
		delete[] prodotti;
	}
	
	void carica(unsigned int prodotto, unsigned int quantita)
	{
		if (prodotto < numero_prodotti)
			prodotti[prodotto] += quantita;
	}
	
	int scarica(unsigned int prodotto, unsigned int quantita)
	{
		if (prodotti[prodotto] == 0)
			return -2;
		if (prodotti[prodotto] < quantita)
		{
			prodotti[prodotto] = 0;
			return -1;
		}
		prodotti[prodotto] -= quantita;
		return 0;
	}
};

