
#include "coda.h"


Coda::Coda(void)
{
 dimensione = 100;
 elementi = new int[100]; // inizializzazione vettore di 100 elementi
 primo = 0;
 ultimo = 0;
 lunghezza = 0;
}

Coda::Coda(int dim)
{
 dimensione = dim;
 elementi = new int[dim]; // inizializzazione vettore di DIM elementi
 primo = 0;
 ultimo = 0;
 lunghezza = 0;
}

Coda::~Coda(void)
{
 delete elementi;
}

void Coda::push(int elemento)
{
 // si inserisce l'elemento solo se la coda non e' piena
 if (lunghezza < dimensione)
   {
    elementi[ultimo] = elemento;
    ultimo++;
    if (ultimo >= dimensione)
      ultimo = 0;
    lunghezza++;
   }
}

int Coda::pop(void)
{
 int elemento;
 
 if (lunghezza > 0)
   {
    lunghezza--;
    elemento = elementi[primo];
    primo++;
    if (primo >= dimensione)
      primo = 0;
    return elemento;
   }
 // se la coda e' vuota si restituisce il valore zero
 return 0;
}

int Coda::getLunghezza(void)
{
 return lunghezza;
}
