
template <class T>
class Pila
{
 private:
 
 T* elementi;
 int dimensione;
 int lunghezza;

 public:

 Pila(int dim) // costruttore
 {
  dimensione = dim;
  elementi = new T[dim];
  lunghezza = 0;
 }

 ~Pila(void) // distruttore
 {
  delete elementi;
 }
 
 void push(T elemento)
 {
  // si inserisce lelemento solo se la pila non e piena 
  if (lunghezza < dimensione) 
    {
     elementi[lunghezza] = elemento;
     lunghezza++;
    }
 }

 T pop(void)
 {
  if (lunghezza > 0)
    {
     lunghezza--;
     return elementi[lunghezza];
    }
  // se la coda e vuota si restituisce il valore zero
  return 0;
 }

 int getLunghezza(void)
 {
  return lunghezza;
 }

};
